Welcome to Minesweeper_SolverV2!

When I was a kid, I thought this game was just a game of luck. Click and get lucky enough, and you can eventually beat the game. One of my older cousins corrected me and showed me what the numbers meant and how you can predict what squares are safe and which ones aren't. From that point on, I have loved this game. I've played hours and hours of it and learned all of the "advanced logic" and beaten it numerous times. When I started learning Python, it was only natural that I eventually make a program designed to beat Minesweeper. 

This program was created with Python and with the help of a couple of different modules, Selenium and Beautiful Soup 4. These modules allow the program to open and manipulate an instance of Google Chrome. Next, I used a web-based version of the game on https://minesweeperonline.com/. The modules allow the program to scrape the website, so the computer knows where all of the squares are, but the logic of which square specifically to click was coded into the program by me. 

The logic of the game is based on the relationships between the squares. If you look at the code in Minesweeper_SolverV2.py, the program will search out the squares and create a list of unsolved squares coordinates (unsolved_squares_coords) based on their column and row. The program iterates through that list and flags or clears whatever spaces it can, then removes the flagged/cleared spaces from the list of unsolved squares. This is made possible by taking each square and examining its adjacent squares (see adjacent()). The simple_sweep() function is called to take the more obvious cases, where a 1-space only has 1 unsolved adjacent square (meaning it must be a bomb) or a 1-space already has 1 flagged square within its adjacents (meaning the rest of the unsolved spaces within the adjacents can be cleared). The advanced_sweep(), as expected, takes on the more difficult or complicated cases. This function will start with an unsolved square and then examine each of the adjacents and look at the adjacents of the adjacent. It wants to figure out if we can learn anything by examining the overlap in those adjacent relationships. At the risk of getting overly-confusing, suppose you have an unsolved square, square_A. Square_B is an adjacent of an adjacent of square_A, meaning that at least some of square_B's adjacent squares overlap with square_A's adjacent squares. Whether the overlap is complete, meaning that all of square_B's unsolved adjacent squares are adjacents of square_A, or the overlap is partial, meaning that one or more of square_B's remaining unsolved adjacent squares are not adjacents of square_A, we gain information and can possibly infer some things about the locations of the bombs. For exmaple, if the relationship is one of partial overlap and the amount of bombs needed for square_B is greater than the number of non-overlapping spaces, we can determine the minimum amount of bombs that will exist within the overlap. If that number is equal to the number of bombs needed for square_A, we can clear all of square_A's non_overlapping spaces. There are plenty of other scenarios to consider, and I've tried to add brief comments within the Minesweeper_SolverV2.py program to explain (or at least hint at) the logic.

In order for the program to work, you will need to install a version of chromedriver on your system. You can download whatever version of chromedriver that you need here: https://chromedriver.chromium.org/downloads. Make sure you download the correct version of chromedriver, corresponding to whichever version of chrome that you are running. 

The program is also designed to save some data about the results in a file called "minesweeper_solver_results.xlsx." Before you start, make sure you update the Minesweeper_SolverV2.py file with the correct file locations for both chromedriver and the .xlsx file.

This program was a lot of fun for me to make, and I really hope that you enjoy it! If you have any questions or recommendations for improvements, feel free to reach out to me via my linkedin page: https://www.linkedin.com/in/daniel-marolf/

Quick note: For those of you who have played Minesweeper a lot, you know that not every game of Minesweeper can be solved. Oftentimes, you are left with a scenario where you get stuck and have to guess. (For instance, you can get to the very end of the game and have 1 bomb left with two spaces side by side, where either can be the bomb. In this scenario, it comes down to a guess and there's a 50% chance you win, and a 50% chance you lose.) This program is designed to randomly click an unsolved square in those scenarios. So sometimes it wins and sometimes it loses. Aside from cheating, a 100% accuracy in Minesweeper is impossible (to my knowledge).
